/* 
* -cr_beg-
* ********************************************************************
* IBM Confidential
* OCO Source Materials
* 5724-U38, 5724-U39, 5724-U48, 5655-V17, 5655-V19, 5655-V35, 5655-V37
* Copyright IBM Corp. 2013
* The source code for this program is not published or otherwise
* divested of its trade secrets, irrespective of what has
* been deposited with the U.S. Copyright Office.
* ********************************************************************
* -cr_end-
*/ 
//#pragma once
#include <oci.h>
extern "C"
{
#include "ODPPCmnAPI.h"
#include "ODPPCmnErrCodes.h"
}

#ifndef __ORACLEDATA__
#define __ORACLEDATA__

#define ODPPDATATYPE_OCI_NUMBER        1001
#define ODPPDATATYPE_OCI_DATETIME      1002
#define ODPPDATATYPE_OCI_STRING        1003
#define ODPPDATATYPE_OCI_DATE          1004

class COracleData
{
protected:
   short       msDataType;
   short       msNullInd;
   int         miLength;
   int         miCharacterSetId;
   int         miCharSetForm;

public:
   
   COracleData(void);
   short    GetDataType(void);
   short    GetNullInd(void);
   int      GetLength(void);
   int      GetCharsetId(void);
   int      GetCharsetForm(void);

   RETVAL   SetDataType(short sDataType);
   RETVAL   SetNullInd(short sNullInd);
   RETVAL   SetLength(int iLength);
   RETVAL   SetCharsetId(int iCharsetId);
   RETVAL   SetCharsetForm(int iCharsetForm);

   virtual RETVAL SetString( 
                  char *pStr,
                  short sNullInd,
                  int iLen,
                  int iCharsetId,
                  int iCharsetForm);

   virtual RETVAL SetOciNumber( 
                  OCINumber *pNum, 
                  short sNullInd);

   virtual RETVAL SetTinyInt( 
                  char *pTinyInt, 
                  short sNullInd);
   
   virtual RETVAL SetUTinyInt( 
                  unsigned char *pUTinyInt, 
                  short sNullInd);

   virtual RETVAL SetShort(  
                  short *pShort, 
                  short sNullInd);
   
   virtual RETVAL SetUShort(  
                  unsigned short *pUShort, 
                  short sNullInd);
   
   virtual RETVAL SetInt(  
                  int *pInt, 
                  short sNullInd);
   
   virtual RETVAL SetUInt(  
                  unsigned int *pUInt, 
                  short sNullInd);

   virtual RETVAL SetLong(  
                  long *pLong, 
                  short sNullInd);
   
   virtual RETVAL SetULong(  
                  unsigned long *pULong, 
                  short sNullInd);

   virtual RETVAL SetFloat(  
                  float *pFloat, 
                  short sNullInd);

   virtual RETVAL SetDouble(  
                  double *pDbl, 
                  short sNullInd);

   virtual RETVAL SetDateTime( 
                  OCIDateTime *pDT,   
                  short sNullInd);

   virtual RETVAL SetDate( 
                  OCIDate *pD,   
                  short sNullInd);

   virtual RETVAL GetString( 
                  char **pStr,
                  short *pNullInd,
                  int *pLen,
                  int *pCharsetId,
                  int *pCharsetForm);

   virtual RETVAL GetOciNumber( 
                  OCINumber **pNum,
                  short *pNullInd);

   virtual RETVAL  GetTinyInt( 
                  char **pTinyInt, 
                  short *pNullInd);
   
   virtual RETVAL  GetUTinyInt( 
                  unsigned char **pUTinyInt, 
                  short *pNullInd);

   virtual RETVAL  GetShort( 
                  short **pShort,
                  short *pNullInd);

   virtual RETVAL  GetUShort( 
                  unsigned short **pUShort,
                  short *pNullInd);

   virtual RETVAL  GetInteger( 
                  int **pInt,
                  short *pNullInd);

   virtual RETVAL  GetUInteger( 
                  unsigned int **pUInt,   
                  short *pNullInd);

   virtual RETVAL  GetLong( 
                  long **pLong,
                  short *pNullInd);

   virtual RETVAL  GetULong( 
                  unsigned long **pULong,
                  short *pNullInd);

   virtual RETVAL  GetFloat(  
               float **pFlt,
               short *pNullInd);
   
   virtual RETVAL  GetDouble( 
               double **pDbl,
               short *pNullInd);

   virtual RETVAL GetDateTime( 
                  OCIDateTime **pDT,
                  short *pNullInd);

   virtual RETVAL GetDate( 
                  OCIDate **pD,
                  short *pNullInd);

   virtual ~COracleData(void);
};

class COracleNumber : public COracleData
{
private:
   
   typedef union ORANUMDATA
   {
      OCINumber         *mpOciNumber;
      unsigned char     *putData;
      char              *ptData;
      unsigned short    *pusData;
      short             *psData;
      unsigned int      *puiData;
      int               *piData;
      unsigned long     *pulData;
      long              *plData;
      float             *pFloat;
      double            *pDbl;
   }ORANUMDATA;

   ORANUMDATA oraData;
public:
   COracleNumber(void);

   //Various constructors for different data types
   COracleNumber( OCINumber *pNum, 
                  short sNullInd);
   
   COracleNumber( char *pTinyInt, 
                  short sNullInd);
   
   COracleNumber( unsigned char *pUTinyInt, 
                  short sNullInd);

   COracleNumber( short *pShort, 
                  short sNullInd);
   
   COracleNumber( unsigned short *pUShort, 
                  short sNullInd);
   
   COracleNumber( int *pInt, 
                  short sNullInd);
   
   COracleNumber( unsigned int *pUInt, 
                  short sNullInd);

   COracleNumber( long *pLong, 
                  short sNullInd);
   
   COracleNumber( unsigned long *pULong, 
                  short sNullInd);

   COracleNumber( float *pFloat, 
                  short sNullInd);

   COracleNumber( double *pDbl, 
                  short sNullInd);

   RETVAL SetOciNumber( 
                  OCINumber *pNum, 
                  short sNullInd);

   RETVAL SetTinyInt( 
                  char *pTinyInt, 
                  short sNullInd);
   
   RETVAL SetUTinyInt( 
                  unsigned char *pUTinyInt, 
                  short sNullInd);

   RETVAL SetShort(  
                  short *pShort, 
                  short sNullInd);
   
   RETVAL SetUShort(  
                  unsigned short *pUShort, 
                  short sNullInd);
   
   RETVAL SetInt(  
                  int *pInt, 
                  short sNullInd);
   
   RETVAL SetUInt(  
                  unsigned int *pUInt, 
                  short sNullInd);

   RETVAL SetLong(  
                  long *pLong, 
                  short sNullInd);
   
   RETVAL SetULong(  
                  unsigned long *pULong, 
                  short sNullInd);

   RETVAL SetFloat(  
                  float *pFloat, 
                  short sNullInd);

   RETVAL SetDouble(  
                  double *pDbl, 
                  short sNullInd);

   RETVAL GetOciNumber( 
                  OCINumber **pNum,
                  short *pNullInd);

   RETVAL GetTinyInt( 
                  char **pTinyInt, 
                  short *pNullInd);
   
   RETVAL GetUTinyInt( 
                  unsigned char **pUTinyInt, 
                  short *pNullInd);

   RETVAL GetShort( 
                  short **pShort,
                  short *pNullInd);

   RETVAL GetUShort( 
                  unsigned short **pUShort,
                  short *pNullInd);

   RETVAL GetInteger( 
                  int **pInt,
                  short *pNullInd);

   RETVAL GetUInteger( 
                  unsigned int **pUInt,
                  short *pNullInd);

   RETVAL GetLong( 
                  long **pLong,
                  short *pNullInd);

   RETVAL GetULong( 
                  unsigned long **pULong,
                  short *pNullInd);

   RETVAL GetFloat(  
               float **pFlt,
               short *pNullInd);
   
   RETVAL GetDouble( 
               double **pDbl,
               short *pNullInd);

               
   virtual ~COracleNumber(void);
};

class COracleString : public COracleData
{
private:
   char     *mpStr;

public:
   COracleString( void);

   //Creates a OracleString instance with supplie data
   COracleString( char *pStr,
                  short sNullInd,
                  int iLen,
                  int iCharsetId,
                  int iCharsetForm);

   RETVAL GetString( 
                  char **pStr,
                  short *pNullInd,
                  int *pLen,
                  int *pCharsetId,
                  int *pCharsetForm);

   RETVAL SetString( 
                  char *pStr,
                  short sNullInd,
                  int iLen,
                  int iCharsetId,
                  int iCharsetForm);

   virtual ~COracleString(void);
};

class COracleDateTime : public COracleData
{
private:
   OCIDateTime    *mpOciDateTime;
   OCIDate        *mpOciDate;

public:
   COracleDateTime(void);
   COracleDateTime(OCIDateTime *pDateTime, 
                   short sNullInd);
   COracleDateTime(OCIDate *pDate, 
                   short sNullInd);

   RETVAL GetDateTime( 
                  OCIDateTime **pDT,
                  short *pNullInd);
   RETVAL GetDate( 
                  OCIDate **pD,
                  short *pNullInd);

   RETVAL SetDateTime( 
                  OCIDateTime *pDT,   
                  short sNullInd);
   RETVAL SetDate( 
                  OCIDate *pD,   
                  short sNullInd);

   virtual ~COracleDateTime(void);
};

#endif //__ORACLEDATA__
